/*
 * Copyright (C) 2018 Adam Retter
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package org.exist.storage.blob;

import javax.annotation.Nullable;

/**
 * Blob Store Service interface.
 *
 * @author Adam Retter <adam@evolvedbinary.com>
 */
public interface BlobStoreService {

    /**
     * Return the Blob Store.
     *
     * @return the Blob Store, or null if the service is not prepared.
     */
    @Nullable BlobStore getBlobStore();
}
