package org.exist.storage.serializers;

import org.exist.indexing.AbstractMatchListener;
import org.exist.storage.DBBroker;

/**
 * Base class for custom filters which can be applied to the serialization
 * stream generated by the {@link org.exist.storage.serializers.Serializer}.
 * Custom filters can be registered in conf.xml.
 *
 * TODO: MatchListener should probably be renamed into SerializationFilter
 * or similar.
 */
public abstract class CustomMatchListener extends AbstractMatchListener {

    private DBBroker broker;

    protected void reset() {
        setCurrentNode(null);
    }

    protected void setBroker(DBBroker broker) {
        this.broker = broker;
    }

    protected DBBroker getBroker() {
        return broker;
    }
}